# Enum Class ClassFile.LineNumbersOption

java.lang.Object
java.lang.Enum<ClassFile.LineNumbersOption>
java.lang.classfile.ClassFile.LineNumbersOption

All Implemented Interfaces:
  `Serializable, ClassFile.Option, Comparable<ClassFile.LineNumbersOption>, Constable`

Enclosing interface:
  `ClassFile`

public static enum ClassFile.LineNumbersOption extends Enum<ClassFile.LineNumbersOption> implements ClassFile.Option
The option describing whether to process or discard `LineNumber`s in the traversal of a `CodeModel` or a `CodeBuilder`. The default is `PASS_LINE_NUMBERS` to process all line number entries as all other `CodeElement`.

Discarding line numbers may reduce the overhead of parsing or transforming `class` files and has no impact on the run-time behavior.

Since:
  24
See Also:
  - `ClassFile.DebugElementsOption`

## Nested Class Summary

### Nested classes/interfaces declared in class Enum

`Enum.EnumDesc<E>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`DROP_LINE_NUMBERS`
Drop `LineNumber` from traversal and builders.
`PASS_LINE_NUMBERS`
Process `LineNumber` like other member elements of a `CodeModel`.

## Method Summary

Modifier and Type
Method
Description
`static ClassFile.LineNumbersOption`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static ClassFile.LineNumbersOption[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods declared in class Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods declared in class Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### PASS_LINE_NUMBERS

public static final ClassFile.LineNumbersOption PASS_LINE_NUMBERS
Process `LineNumber` like other member elements of a `CodeModel`.

### DROP_LINE_NUMBERS

public static final ClassFile.LineNumbersOption DROP_LINE_NUMBERS
Drop `LineNumber` from traversal and builders.

## Method Details

### values

public static ClassFile.LineNumbersOption[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static ClassFile.LineNumbersOption valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null